/******************************************************************************
 * 
 *	Projektarbeit Microcontroller TSU 6.Semester
 *	A/D-Converter
 *	Temparatur ber LCD und RS232 ausgeben
 *  R.Hrlimann & A.Jetzer & A.Fleckner
 *  TSU 03.Dezember 2001
 *
 ******************************************************************************
*/

#include <stdio.h>
#include "ioh83067.h"
#include "CB-TSU2.h"

long int Temp1;
long int Temp2;
int Kal;
char buffer[21];
long int i;
int c;

main()
{
CBTSU_RSInit();                       // Initialisierung der RS232 Schnittstelle
LCD_Init();                           // Initialisierung des Displays
LCD_IWrite(0x01);
c = 0;                                //Variable fr Darstellung der 1.Zeile
Kal = 0;										  //Eingabe des Kallibrierwertes
Kal = Kal * 10;

PBDR |= 0x20;
ADCSR = 0x00;  						     // Initialisieren A/D-Conv.
ADDRAH = 0x0000;                      // Initialisieren Register in der,der Wert eingelesen wird
ADDRAL = 0x0000;
CBTSU_DispString(2,"-Temparaturmessung--");		//Schreib auf Zeile 1 den Titel

while(1)
	{
   ADCSR = 0x30;					  	      //Start A/D-Converter
	while(ADCSR != 0xB0)
	Temp1 = ADDRAH;						   //bergabe des Temperaturwertes
	if(CBTSU_Schalter & 0x02)           //Darstellung auf dem Display in Kelvin
		{
		Temp1 = Temp1 + 2731 + Kal;      //Berechnung von Celsius in Kelvin
		Temp2 = Temp1 %10;
		Temp1 = Temp1 / 10;
		sprintf(buffer,"T: %d.%d Grad Kelvin ", Temp1, Temp2);
		}
	if(CBTSU_Schalter & 0x04)				//Darstellung auf dem Display in Fahrenheit
		{
      Temp1 = Temp1 + Kal;					//Einbezug des Kallibrierwertes
		Temp1 = 5 * Temp1;               //Berechnung von Celsius in Fahrenheit
      Temp1 = Temp1 / 8;
      Temp1 = Temp1 + 320;
		Temp2 = Temp1 %10;
		Temp1 = Temp1 / 10;
		sprintf(buffer,"T: %d.%d Fahrenheit  ", Temp1, Temp2);
		}
	if(CBTSU_Schalter & 0x08)	         //Darstellung auf dem Display in Celsius
		{
      Temp1 = Temp1 + Kal;
		Temp2 = Temp1 %10;
		Temp1 = Temp1 / 10;
		sprintf(buffer,"T: %d.%d Grad Celsius", Temp1, Temp2);
      }
   if(c==0);
   else
   	{
		for (i=0;i<200000;i++);					//Zeitschlaufe fr eine bessere Darstellung
      }
	CBTSU_DispString(3,buffer); 			//Schreibt Zeile 3 in buffer
	if(CBTSU_Schalter & 0x01)				//Ausgabe an RS232 Schnittstelle
		{
		CBTSU_RSWriteLn(buffer);
		CBTSU_RSWriteLn("\n");
		}

   switch(c)
   	{
   	case 0: //Anzeige Programmer
   		{
      	CBTSU_DispString(1,"Program: A.Jetzer   ");
         break;
         }
   	case 5: //Anzeige Dukumentator
   		{
         CBTSU_DispString(1,"Doku: R.Huerlimann  ");
         break;
         }
   	case 10: //Anzeige Beides
   		{
         CBTSU_DispString(1,"Beides: A.Fleckner  ");
   		break;
         }
      case 15: //Anzeige Datum
   		{
         CBTSU_DispString(1,"24.11.2001 MC 2     ");
   		break;
         }
   	}

   c=c++;
   if(c==20)
   	c=0;

	}
}



